//---------------------------------------------------------------------------
// TestGeneralizedHarvestRegime
//---------------------------------------------------------------------------
#if !defined(TestGeneralizedHarvestRegime_H)
  #define TestGeneralizedHarvestRegime_H

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>

class clSimManager;

/**
* Tests the clFIAHarvest class.
*/
class clTestGeneralizedHarvestRegime : public CppUnit::TestFixture {

  public:

  /**
  * Combines the testing into one function.
  */
  void TestGeneralizedHarvestRegime();

  protected:

  /**
  * Tests the decision to log the plot.
  * @param p_oSimManager Sim manager object for doing the run.
  */
  void TestRun1(clSimManager *p_oSimManager);

  /**
  * Tests the decision to log the plot.
  * @param p_oSimManager Sim manager object for doing the run.
  */
  void TestRun2(clSimManager *p_oSimManager);

  /**
  * Tests the decision to log the plot.
  * @param p_oSimManager Sim manager object for doing the run.
  */
  void TestRun3(clSimManager *p_oSimManager);

  /**
  * Tests the decision to log the plot.
  * @param p_oSimManager Sim manager object for doing the run.
  */
  void TestRun4(clSimManager *p_oSimManager);

  /**
  * Writes a parameter file to direct testing.
  * @return Filename written.
  */
  char* WriteXMLFileSet1(int iNumTreesPerSpecies);

  /**
  * Writes a parameter file to direct testing.
  * @return Filename written.
  */
  char* WriteXMLFile3();

  /**
  * Writes a parameter file to direct testing.
  * @return Filename written.
  */
  char* WriteXMLFile4();
};
//---------------------------------------------------------------------------
#endif // TestGeneralizedHarvestRegime_H
