//---------------------------------------------------------------------------
// TestGhostTreePopulation
//---------------------------------------------------------------------------
#if !defined(TestGhostTreePopulation_H)
  #define TestGhostTreePopulation_H

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>

class clSimManager;

/**
 * This class tests the ghost tree population.
 */
class clTestGhostTreePopulation : public CppUnit::TestFixture
{

  public:

  /**Rolls all tests into one.*/
  void TestGhostTreePopulation();

  private:

  /**
  * Tests normal processing. This run has no snags.
  * @param p_oSimManager Sim Manager object.
  */
  void TestGhostTreePopulationRun1(clSimManager *p_oSimManager);

  /**
  * Tests normal processing. This run has snags.
  * @param p_oSimManager Sim Manager object.
  */
  void TestGhostTreePopulationRun2(clSimManager *p_oSimManager);

  /**
   * Writes a parameter file to direct testing for run one.
   * @return Filename written.
   */
  char * WriteXMLFile1();

  /**
   * Writes a parameter file to direct testing for run two.
   * @return Filename written.
   */
  char * WriteXMLFile2();

};
//---------------------------------------------------------------------------

#endif // TestGhostTreePopulation_H
