//---------------------------------------------------------------------------
// TestLaggedPostHarvestGrowth
//---------------------------------------------------------------------------
#if !defined(TestLaggedPostHarvestGrowth_H)
  #define TestLaggedPostHarvestGrowth_H

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>

class clSimManager;

/**
* Tests the clLaggedPostHarvestGrowth class.
*/
class clTestLaggedPostHarvestGrowth : public CppUnit::TestFixture {

  public:

  /**
  * Tests pre- and post-harvest growth over 4 timesteps with a timestep length of 2 years. 
  * 10 identical trees are created and have growth applied to them. In the second timestep,
  * 5 of these trees are harvested. The diameter of a representative tree is checked after each 
  * timestep to make sure it is correct.
  * @param p_oSimManager Sim manager object for doing the run.
  */
  void TestLaggedPostHarvestGrowth();

  protected:

  /**
  * Writes a parameter file to direct testing.
  * @return Filename written.
  */
  char* WriteXMLFile();

};
//---------------------------------------------------------------------------
#endif // TestLaggedPostHarvestGrowth_H
