//---------------------------------------------------------------------------
// TestMerchantableStemWoodVolume.cpp
//---------------------------------------------------------------------------
#include "TestMerchantableStemWoodVolume.h"
#include <fstream>
#include <math.h>
#include "TreePopulation.h"
#include "SimManager.h"
#include "BehaviorBase.h"

////////////////////////////////////////////////////////////////////////////
//  TestMerchantableStemWoodVolume()
////////////////////////////////////////////////////////////////////////////
void clTestMerchantableStemWoodVolume::TestMerchantableStemWoodVolume() {
  clSimManager *p_oSimManager = new clSimManager(4, 2, "");

  TestNormalProcessing(p_oSimManager);
  TestErrorProcessing(p_oSimManager);

  delete p_oSimManager;
}

////////////////////////////////////////////////////////////////////////////
//  TestNormalProcessing()
////////////////////////////////////////////////////////////////////////////
void clTestMerchantableStemWoodVolume::TestNormalProcessing(clSimManager *p_oSimManager) {
  clTreePopulation * p_oPop;
  clTree **p_oTrees; //array to hold our target trees
  float fBiomass, fExpectedBiomass, fVolume, fExpectedVolume, fDiam;
  int iSpecies, iNumTrees = 54, iCount;

  //Load our test file and get our tree population pointers
  p_oSimManager->ReadFile( WriteXMLFile1() );
  p_oPop = ( clTreePopulation * ) p_oSimManager->GetPopulationObject( "treepopulation" );


  //Create our trees
  p_oTrees = new clTree*[iNumTrees];

  //Create our trees
  iCount = 0;

  //Species 1
  iSpecies = 0;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 2
  iSpecies = 1;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 3
  iSpecies = 2;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 4
  iSpecies = 3;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 5
  iSpecies = 4;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 6
  iSpecies = 5;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 7
  iSpecies = 6;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 8
  iSpecies = 7;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 9
  iSpecies = 8;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 10
  iSpecies = 9;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 11
  iSpecies = 10;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 12
  iSpecies = 11;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //No species 13

  //Species 14
  iSpecies = 13;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 15
  iSpecies = 14;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 16
  iSpecies = 15;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 17
  iSpecies = 16;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 18
  iSpecies = 17;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  //Species 19
  iSpecies = 18;
  fDiam = 5;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::sapling, fDiam);
  iCount++;

  fDiam = 50;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;

  fDiam = 100;
  p_oTrees[iCount] = p_oPop->CreateTree(10, 10, iSpecies, clTreePopulation::adult, fDiam);
  iCount++;


  //Now do the run
  p_oSimManager->RunSim(1);

  iCount = 0;
  //Check the biomass and volume for each tree
  p_oTrees[0]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.236570511;
  fExpectedVolume = 254.3845781;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[1]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 22.59230844;
  fExpectedVolume = 64491.30535;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[2]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 89.12509381;
  fExpectedVolume = 268594.2379;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[3]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.004726261;
  fExpectedVolume = 9.610125088;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[4]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.21483616;
  fExpectedVolume = 3418.774093;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[5]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 6.45654229;
  fExpectedVolume = 18500.94366;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[6]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000484212;
  fExpectedVolume = 0.169847977;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[7]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.207508125;
  fExpectedVolume = 98.49861317;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[8]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.286311214;
  fExpectedVolume = 620.9253391;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[9]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 7.92831E-05;
  fExpectedVolume = 0.028439153;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[10]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000122682;
  fExpectedVolume = 0.054060996;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[11]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000139912;
  fExpectedVolume = 0.062362596;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[12]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.007329968;
  fExpectedVolume = 1.474579939;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[13]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 10.57065981;
  fExpectedVolume = 737.7104997;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[14]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 94.41822959;
  fExpectedVolume = 6212.927086;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[15]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000201974;
  fExpectedVolume = 0.10880308;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[16]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.070193118;
  fExpectedVolume = 16.89242142;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[17]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.408518523;
  fExpectedVolume = 94.00858146;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[18]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.008919081;
  fExpectedVolume = 9.406263377;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[19]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 5.575966195;
  fExpectedVolume = 15610.88496;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[20]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 38.72576449;
  fExpectedVolume = 114462.5782;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[21]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 9.84004E-06;
  fExpectedVolume = 0.019630693;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[22]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.00592648;
  fExpectedVolume = 16.36352958;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[23]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.040700524;
  fExpectedVolume = 114.4251142;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[24]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.11718E-06;
  fExpectedVolume = 0.000559821;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[25]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.001253493;
  fExpectedVolume = 0.850000064;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[26]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.010381581;
  fExpectedVolume = 7.159105523;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[27]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.236570511;
  fExpectedVolume = 121.2268063;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[28]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 22.59230844;
  fExpectedVolume = 14222.17588;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[29]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 89.12509381;
  fExpectedVolume = 56750.57826;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[30]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.004726261;
  fExpectedVolume = 1.358269332;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[31]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.21483616;
  fExpectedVolume = 121.1165632;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[32]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 6.45654229;
  fExpectedVolume = 606.9352534;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[33]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000483244;
  fExpectedVolume = 0.322950392;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[34]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.207093615;
  fExpectedVolume = 61.82819019;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[35]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.283741727;
  fExpectedVolume = 366.4847064;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[36]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 7.92831E-05;
  fExpectedVolume = 0.083613724;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[37]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000122682;
  fExpectedVolume = 0.343469325;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[38]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000139912;
  fExpectedVolume = 0.413541765;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[39]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.007329968;
  fExpectedVolume = 15.50053778;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[40]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 10.57065981;
  fExpectedVolume = 30937.70754;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[41]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 94.41822959;
  fExpectedVolume = 281373.4223;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[42]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.000201974;
  fExpectedVolume = 0.094462305;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[43]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.070193118;
  fExpectedVolume = 44.42508615;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[44]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.408518523;
  fExpectedVolume = 262.9322249;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[45]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.008919081;
  fExpectedVolume = 4.36269449;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[46]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 5.575966195;
  fExpectedVolume = 3350.596902;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[47]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 38.72576449;
  fExpectedVolume = 23537.85619;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[48]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 9.84004E-06;
  fExpectedVolume = 0.002639379;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[49]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.00592648;
  fExpectedVolume = 0.551466865;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[50]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.040700524;
  fExpectedVolume = 3.570911941;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[51]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 1.11459E-06;
  fExpectedVolume = 0.0008693;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[52]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.001250592;
  fExpectedVolume = 0.435732753;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);
  iCount++;

  p_oTrees[53]->GetValue(p_oPop->GetFloatDataCode("Biomass", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fBiomass);
  p_oTrees[iCount]->GetValue(p_oPop->GetFloatDataCode("FIA_Volume", p_oTrees[iCount]->GetSpecies(), p_oTrees[iCount]->GetType()), &fVolume);
  fExpectedBiomass = 0.010357553;
  fExpectedVolume = 3.450802201;
  CPPUNIT_ASSERT(fabs(fExpectedBiomass - fBiomass)/fExpectedBiomass < 0.1);
  CPPUNIT_ASSERT(fabs(fExpectedVolume - fVolume)/fExpectedVolume < 0.1);

  delete[] p_oTrees;
}


////////////////////////////////////////////////////////////////////////////
//  TestErrorProcessing()
////////////////////////////////////////////////////////////////////////////
void clTestMerchantableStemWoodVolume::TestErrorProcessing(clSimManager *p_oSimManager) {

  try
  {
    p_oSimManager->ReadFile(WriteXMLErrorFile1());
    CppUnit::Asserter::fail("TestMerchantableStemWoodVolume error processing didn't catch error for WriteXMLErrorFile1.");
  }
  catch (modelErr err)
  {
    if (strstr(err.cFunction, "clMerchantableStemWoodVolume::GetData") == NULL)
    {
      CppUnit::Asserter::fail("TestMerchantableStemWoodVolume error processing caught wrong error for WriteXMLErrorFile1.");
    }
    ;
  }

  try
  {
    p_oSimManager->ReadFile(WriteXMLErrorFile2());
    CppUnit::Asserter::fail("TestMerchantableStemWoodVolume error processing didn't catch error for WriteXMLErrorFile3.");
  }
  catch (modelErr err)
  {
    if (strstr(err.cFunction, "clMerchantableStemWoodVolume::RegisterTreeDataMembers") == NULL)
    {
      CppUnit::Asserter::fail("TestMerchantableStemWoodVolume error processing caught wrong error for WriteXMLErrorFile3.");
    }
    ;
  }
}

////////////////////////////////////////////////////////////////////////////
//  WriteXMLFile1()
////////////////////////////////////////////////////////////////////////////
char* clTestMerchantableStemWoodVolume::WriteXMLFile1() {
  using namespace std;
  char *cFileString = "TestFile1.xml";

  //Open file to write to
  fstream oOut;
  oOut.open(cFileString, ios::out | ios::trunc);

  oOut << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>"
       << "<paramFile fileCode=\"06010101\">"
       << "<plot>"
       << "<timesteps>2</timesteps>"
       << "<yearsPerTimestep>1</yearsPerTimestep>"
       << "<randomSeed>1</randomSeed>"
       << "<plot_lenX>200.0</plot_lenX>"
       << "<plot_lenY>200.0</plot_lenY>"
       << "<plot_latitude>55.37</plot_latitude>"
       << "<plot_precip_mm_yr>1150.645781</plot_precip_mm_yr>"
       << "<plot_temp_C>12.88171785</plot_temp_C>"
       << "</plot>"
       << "<trees>"
       << "<tr_speciesList>"
       << "<tr_species speciesName=\"Species_1\" />"
       << "<tr_species speciesName=\"Species_2\" />"
       << "<tr_species speciesName=\"Species_3\" />"
       << "<tr_species speciesName=\"Species_4\" />"
       << "<tr_species speciesName=\"Species_5\" />"
       << "<tr_species speciesName=\"Species_6\" />"
       << "<tr_species speciesName=\"Species_7\" />"
       << "<tr_species speciesName=\"Species_8\" />"
       << "<tr_species speciesName=\"Species_9\" />"
       << "<tr_species speciesName=\"Species_10\" />"
       << "<tr_species speciesName=\"Species_11\" />"
       << "<tr_species speciesName=\"Species_12\" />"
       << "<tr_species speciesName=\"Species_13\" />"
       << "<tr_species speciesName=\"Species_14\" />"
       << "<tr_species speciesName=\"Species_15\" />"
       << "<tr_species speciesName=\"Species_16\" />"
       << "<tr_species speciesName=\"Species_17\" />"
       << "<tr_species speciesName=\"Species_18\" />"
       << "<tr_species speciesName=\"Species_19\" />"
       << "</tr_speciesList>"
       << "<tr_seedDiam10Cm>0.1</tr_seedDiam10Cm>"
       << "<tr_minAdultDBH>"
       << "<tr_madVal species=\"Species_1\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_2\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_3\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_4\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_5\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_6\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_7\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_8\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_9\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_10\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_11\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_12\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_13\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_14\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_15\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_16\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_17\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_18\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_19\">4.0</tr_madVal>"
       << "</tr_minAdultDBH>"
       << "<tr_maxSeedlingHeight>"
       << "<tr_mshVal species=\"Species_1\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_2\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_3\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_4\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_5\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_6\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_7\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_8\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_9\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_10\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_11\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_12\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_13\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_14\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_15\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_16\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_17\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_18\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_19\">1.35</tr_mshVal>"
       << "</tr_maxSeedlingHeight>"
       << "</trees>"
       << "<allometry>"
       << "<tr_canopyHeight>"
       << "<tr_chVal species=\"Species_1\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_2\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_3\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_4\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_5\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_6\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_7\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_8\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_9\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_10\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_11\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_12\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_13\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_14\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_15\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_16\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_17\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_18\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_19\">39.48</tr_chVal>"
       << "</tr_canopyHeight>"
       << "<tr_stdAsympCrownRad>"
       << "<tr_sacrVal species=\"Species_1\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_2\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_3\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_4\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_5\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_6\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_7\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_8\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_9\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_10\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_11\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_12\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_13\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_14\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_15\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_16\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_17\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_18\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_19\">0.0549</tr_sacrVal>"
       << "</tr_stdAsympCrownRad>"
       << "<tr_stdCrownRadExp>"
       << "<tr_screVal species=\"Species_1\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_2\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_3\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_4\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_5\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_6\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_7\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_8\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_9\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_10\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_11\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_12\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_13\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_14\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_15\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_16\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_17\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_18\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_19\">1.0</tr_screVal>"
       << "</tr_stdCrownRadExp>"
       << "<tr_conversionDiam10ToDBH>"
       << "<tr_cdtdVal species=\"Species_1\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_2\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_3\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_4\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_5\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_6\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_7\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_8\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_9\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_10\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_11\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_12\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_13\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_14\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_15\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_16\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_17\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_18\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_19\">0.8008</tr_cdtdVal>"
       << "</tr_conversionDiam10ToDBH>"
       << "<tr_interceptDiam10ToDBH>"
       << "<tr_idtdVal species=\"Species_1\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_2\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_3\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_4\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_5\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_6\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_7\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_8\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_9\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_10\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_11\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_12\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_13\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_14\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_15\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_16\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_17\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_18\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_19\">0</tr_idtdVal>"
       << "</tr_interceptDiam10ToDBH>"
       << "<tr_stdAsympCrownHt>"
       << "<tr_sachVal species=\"Species_1\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_2\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_3\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_4\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_5\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_6\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_7\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_8\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_9\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_10\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_12\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_13\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_14\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_15\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_16\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_17\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_18\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_11\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_19\">0.389</tr_sachVal>"
       << "</tr_stdAsympCrownHt>"
       << "<tr_stdCrownHtExp>"
       << "<tr_scheVal species=\"Species_1\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_2\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_3\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_4\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_5\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_6\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_7\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_8\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_9\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_10\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_11\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_12\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_13\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_14\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_15\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_16\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_17\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_18\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_19\">1.0</tr_scheVal>"
       << "</tr_stdCrownHtExp>"
       << "<tr_slopeOfHeight-Diam10>"
       << "<tr_sohdVal species=\"Species_1\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_2\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_3\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_4\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_5\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_6\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_7\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_8\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_9\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_10\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_11\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_12\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_13\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_14\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_15\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_16\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_17\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_18\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_19\">0.03418</tr_sohdVal>"
       << "</tr_slopeOfHeight-Diam10>"
       << "<tr_slopeOfAsymHeight>"
       << "<tr_soahVal species=\"Species_1\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_2\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_3\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_4\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_5\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_6\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_7\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_8\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_9\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_10\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_11\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_12\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_13\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_14\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_15\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_16\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_17\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_18\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_19\">0.0299</tr_soahVal>"
       << "</tr_slopeOfAsymHeight>"
       << "<tr_whatSeedlingHeightDiam>"
       << "<tr_wsehdVal species=\"Species_1\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_2\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_3\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_4\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_5\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_6\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_7\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_8\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_9\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_10\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_11\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_12\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_13\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_14\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_15\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_16\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_17\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_18\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_19\">0</tr_wsehdVal>"
       << "</tr_whatSeedlingHeightDiam>"
       << "<tr_whatSaplingHeightDiam>"
       << "<tr_wsahdVal species=\"Species_1\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_2\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_3\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_4\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_5\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_6\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_7\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_8\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_9\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_10\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_11\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_12\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_13\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_14\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_15\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_16\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_17\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_18\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_19\">0</tr_wsahdVal>"
       << "</tr_whatSaplingHeightDiam>"
       << "<tr_whatAdultHeightDiam>"
       << "<tr_wahdVal species=\"Species_1\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_2\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_3\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_4\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_5\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_6\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_7\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_8\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_9\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_10\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_11\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_12\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_13\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_14\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_15\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_16\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_17\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_18\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_19\">0</tr_wahdVal>"
       << "</tr_whatAdultHeightDiam>"
       << "<tr_whatAdultCrownRadDiam>"
       << "<tr_wacrdVal species=\"Species_1\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_2\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_3\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_4\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_5\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_6\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_7\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_8\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_9\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_10\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_11\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_12\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_13\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_14\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_15\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_16\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_17\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_18\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_19\">0</tr_wacrdVal>"
       << "</tr_whatAdultCrownRadDiam>"
       << "<tr_whatAdultCrownHeightHeight>"
       << "<tr_wachhVal species=\"Species_1\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_2\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_3\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_4\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_5\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_6\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_7\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_8\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_9\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_10\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_11\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_12\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_13\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_14\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_15\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_16\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_17\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_18\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_19\">0</tr_wachhVal>"
       << "</tr_whatAdultCrownHeightHeight>"
       << "<tr_whatSaplingCrownRadDiam>"
       << "<tr_wscrdVal species=\"Species_1\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_2\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_3\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_4\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_5\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_6\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_7\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_8\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_9\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_10\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_11\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_12\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_13\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_14\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_15\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_16\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_17\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_18\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_19\">0</tr_wscrdVal>"
       << "</tr_whatSaplingCrownRadDiam>"
       << "<tr_whatSaplingCrownHeightHeight>"
       << "<tr_wschhVal species=\"Species_1\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_2\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_3\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_4\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_5\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_6\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_7\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_8\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_9\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_10\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_11\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_12\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_13\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_14\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_15\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_16\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_17\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_18\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_19\">0</tr_wschhVal>"
       << "</tr_whatSaplingCrownHeightHeight>"
       << "</allometry>"
       << "<behaviorList>"
       << "<behavior>"
       << "<behaviorName>tree biomass calculator</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_1\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_3\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_4\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_5\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_6\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_7\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_8\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_9\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_10\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_11\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_12\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_14\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_15\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_16\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_17\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_18\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_19\" type=\"Adult\"/>"
       << "</behavior>"
       << "<behavior>"
       << "<behaviorName>FIA Merchantable Stem Wood Volume</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_1\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_3\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_4\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_5\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_6\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_7\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_8\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_9\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_10\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_11\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_12\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_14\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_15\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_16\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_17\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_18\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_19\" type=\"Adult\"/>"
       << "</behavior>"
       << "</behaviorList>";

  oOut << "<analysis>"
       << "<bi_a>"
       << "<bi_aVal species=\"Species_1\">-0.99</bi_aVal>"
       << "<bi_aVal species=\"Species_2\">-1.01</bi_aVal>"
       << "<bi_aVal species=\"Species_3\">-1.09</bi_aVal>"
       << "<bi_aVal species=\"Species_4\">-1.08</bi_aVal>"
       << "<bi_aVal species=\"Species_5\">-1</bi_aVal>"
       << "<bi_aVal species=\"Species_6\">-1.1</bi_aVal>"
       << "<bi_aVal species=\"Species_7\">-0.8</bi_aVal>"
       << "<bi_aVal species=\"Species_8\">-0.95</bi_aVal>"
       << "<bi_aVal species=\"Species_9\">-0.85</bi_aVal>"
       << "<bi_aVal species=\"Species_10\">-0.99</bi_aVal>"
       << "<bi_aVal species=\"Species_11\">-1.01</bi_aVal>"
       << "<bi_aVal species=\"Species_12\">-1.09</bi_aVal>"
       << "<bi_aVal species=\"Species_14\">-1.08</bi_aVal>"
       << "<bi_aVal species=\"Species_15\">-1</bi_aVal>"
       << "<bi_aVal species=\"Species_16\">-1.1</bi_aVal>"
       << "<bi_aVal species=\"Species_17\">-0.8</bi_aVal>"
       << "<bi_aVal species=\"Species_18\">-0.95</bi_aVal>"
       << "<bi_aVal species=\"Species_19\">-0.85</bi_aVal>"
       << "</bi_a>"
       << "<bi_b>"
       << "<bi_bVal species=\"Species_1\">2.2</bi_bVal>"
       << "<bi_bVal species=\"Species_2\">2.41</bi_bVal>"
       << "<bi_bVal species=\"Species_3\">2.35</bi_bVal>"
       << "<bi_bVal species=\"Species_4\">2.37</bi_bVal>"
       << "<bi_bVal species=\"Species_5\">2.43</bi_bVal>"
       << "<bi_bVal species=\"Species_6\">2.31</bi_bVal>"
       << "<bi_bVal species=\"Species_7\">2.33</bi_bVal>"
       << "<bi_bVal species=\"Species_8\">2.46</bi_bVal>"
       << "<bi_bVal species=\"Species_9\">2.44</bi_bVal>"
       << "<bi_bVal species=\"Species_10\">2.2</bi_bVal>"
       << "<bi_bVal species=\"Species_11\">2.41</bi_bVal>"
       << "<bi_bVal species=\"Species_12\">2.35</bi_bVal>"
       << "<bi_bVal species=\"Species_14\">2.37</bi_bVal>"
       << "<bi_bVal species=\"Species_15\">2.43</bi_bVal>"
       << "<bi_bVal species=\"Species_16\">2.31</bi_bVal>"
       << "<bi_bVal species=\"Species_17\">2.33</bi_bVal>"
       << "<bi_bVal species=\"Species_18\">2.46</bi_bVal>"
       << "<bi_bVal species=\"Species_19\">2.44</bi_bVal>"
       << "</bi_b>"
       << "<bi_c>"
       << "<bi_cVal species=\"Species_1\">0.9</bi_cVal>"
       << "<bi_cVal species=\"Species_2\">1</bi_cVal>"
       << "<bi_cVal species=\"Species_3\">1.12</bi_cVal>"
       << "<bi_cVal species=\"Species_4\">0.08</bi_cVal>"
       << "<bi_cVal species=\"Species_5\">1.3</bi_cVal>"
       << "<bi_cVal species=\"Species_6\">1.1</bi_cVal>"
       << "<bi_cVal species=\"Species_7\">1.2</bi_cVal>"
       << "<bi_cVal species=\"Species_8\">1.13</bi_cVal>"
       << "<bi_cVal species=\"Species_9\">1.25</bi_cVal>"
       << "<bi_cVal species=\"Species_10\">0.9</bi_cVal>"
       << "<bi_cVal species=\"Species_11\">1</bi_cVal>"
       << "<bi_cVal species=\"Species_12\">1.12</bi_cVal>"
       << "<bi_cVal species=\"Species_14\">0.08</bi_cVal>"
       << "<bi_cVal species=\"Species_15\">1.3</bi_cVal>"
       << "<bi_cVal species=\"Species_16\">1.1</bi_cVal>"
       << "<bi_cVal species=\"Species_17\">1.2</bi_cVal>"
       << "<bi_cVal species=\"Species_18\">1.13</bi_cVal>"
       << "<bi_cVal species=\"Species_19\">1.25</bi_cVal>"
       << "</bi_c>"
       << "<bi_d>"
       << "<bi_dVal species=\"Species_1\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_2\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_3\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_4\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_5\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_6\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_7\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_8\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_9\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_10\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_11\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_12\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_14\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_15\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_16\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_17\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_18\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_19\">1</bi_dVal>"
       << "</bi_d>"
       << "<bi_e>"
       << "<bi_eVal species=\"Species_1\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_2\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_3\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_4\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_5\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_6\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_7\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_8\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_9\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_10\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_11\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_12\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_14\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_15\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_16\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_17\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_18\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_19\">0</bi_eVal>"
       << "</bi_e>"
       << "<bi_eqID>"
       << "<bi_eiVal species=\"Species_1\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_2\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_3\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_4\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_5\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_6\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_7\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_8\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_9\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_10\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_11\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_12\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_14\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_15\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_16\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_17\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_18\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_19\">1</bi_eiVal>"
       << "</bi_eqID>"
       << "<bi_dbhUnits>"
       << "<bi_duVal species=\"Species_1\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_2\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_3\">2</bi_duVal>"
       << "<bi_duVal species=\"Species_4\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_5\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_6\">2</bi_duVal>"
       << "<bi_duVal species=\"Species_7\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_8\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_9\">2</bi_duVal>"
       << "<bi_duVal species=\"Species_10\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_11\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_12\">2</bi_duVal>"
       << "<bi_duVal species=\"Species_14\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_15\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_16\">2</bi_duVal>"
       << "<bi_duVal species=\"Species_17\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_18\">1</bi_duVal>"
       << "<bi_duVal species=\"Species_19\">2</bi_duVal>"
       << "</bi_dbhUnits>"
       << "<bi_biomassUnits>"
       << "<bi_buVal species=\"Species_1\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_2\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_3\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_4\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_5\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_6\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_7\">0</bi_buVal>"
       << "<bi_buVal species=\"Species_8\">0</bi_buVal>"
       << "<bi_buVal species=\"Species_9\">0</bi_buVal>"
       << "<bi_buVal species=\"Species_10\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_11\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_12\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_14\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_15\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_16\">2</bi_buVal>"
       << "<bi_buVal species=\"Species_17\">0</bi_buVal>"
       << "<bi_buVal species=\"Species_18\">0</bi_buVal>"
       << "<bi_buVal species=\"Species_19\">0</bi_buVal>"
       << "</bi_biomassUnits>"
       << "<bi_useCorrectionFactor>"
       << "<bi_ucfVal species=\"Species_1\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_2\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_3\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_4\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_5\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_6\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_7\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_8\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_9\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_10\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_11\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_12\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_14\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_15\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_16\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_17\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_18\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_19\">1</bi_ucfVal>"
       << "</bi_useCorrectionFactor>"
       << "<bi_correctionFactorValue>"
       << "<bi_cfvVal species=\"Species_1\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_2\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_3\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_4\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_5\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_6\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_7\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_8\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_9\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_10\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_11\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_12\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_14\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_15\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_16\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_17\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_18\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_19\">1</bi_cfvVal>"
       << "</bi_correctionFactorValue>"
       << "<bi_whatDia>"
       << "<bi_wdVal species=\"Species_1\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_2\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_3\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_4\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_5\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_6\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_7\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_8\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_9\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_10\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_11\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_12\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_14\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_15\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_16\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_17\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_18\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_19\">0</bi_wdVal>"
       << "</bi_whatDia>"

       << "<an_fiaVolB1>"
       << "<an_fvb1Val species=\"Species_1\">-0.3065</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_2\">-0.3737</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_3\">-2.0129</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_4\">-2.098</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_5\">-4.0813</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_6\">-2.9584</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_7\">-0.3065</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_8\">-0.3737</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_9\">-2.0129</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_10\">-2.098</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_11\">-4.0813</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_12\">-2.9584</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_14\">-0.3065</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_15\">-0.3737</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_16\">-2.0129</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_17\">-2.098</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_18\">-4.0813</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_19\">-2.9584</an_fvb1Val>"
       << "</an_fiaVolB1>"
       << "<an_fiaVolB2>"
       << "<an_fvb2Val species=\"Species_1\">-5.424</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_2\">-1.8055</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_3\">-1.6805</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_4\">-1.1432</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_5\">5.8816</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_6\">4.4766</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_7\">-5.424</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_8\">-1.8055</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_9\">-1.6805</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_10\">-1.1432</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_11\">5.8816</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_12\">4.4766</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_14\">-5.424</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_15\">-1.8055</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_16\">-1.6805</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_17\">-1.1432</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_18\">5.8816</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_19\">4.4766</an_fvb2Val>"
       << "</an_fiaVolB2>"
       << "<an_fiaVolSpgr>"
       << "<an_fvsVal species=\"Species_1\">0.51</an_fvsVal>"
       << "<an_fvsVal species=\"Species_2\">0.52</an_fvsVal>"
       << "<an_fvsVal species=\"Species_3\">0.6</an_fvsVal>"
       << "<an_fvsVal species=\"Species_4\">0.6</an_fvsVal>"
       << "<an_fvsVal species=\"Species_5\">0.6</an_fvsVal>"
       << "<an_fvsVal species=\"Species_6\">0.52</an_fvsVal>"
       << "<an_fvsVal species=\"Species_7\">0.52</an_fvsVal>"
       << "<an_fvsVal species=\"Species_8\">0.53</an_fvsVal>"
       << "<an_fvsVal species=\"Species_9\">0.42</an_fvsVal>"
       << "<an_fvsVal species=\"Species_10\">0.42</an_fvsVal>"
       << "<an_fvsVal species=\"Species_11\">0.42</an_fvsVal>"
       << "<an_fvsVal species=\"Species_12\">0.42</an_fvsVal>"
       << "<an_fvsVal species=\"Species_14\">0.52</an_fvsVal>"
       << "<an_fvsVal species=\"Species_15\">0.5</an_fvsVal>"
       << "<an_fvsVal species=\"Species_16\">0.45</an_fvsVal>"
       << "<an_fvsVal species=\"Species_17\">0.44</an_fvsVal>"
       << "<an_fvsVal species=\"Species_18\">0.45</an_fvsVal>"
       << "<an_fvsVal species=\"Species_19\">0.36</an_fvsVal>"
       << "</an_fiaVolSpgr>"
       << "</analysis>"
       << "</paramFile>";

  return cFileString;
}


////////////////////////////////////////////////////////////////////////////
//  WriteXMLErrorFile1()
////////////////////////////////////////////////////////////////////////////
char* clTestMerchantableStemWoodVolume::WriteXMLErrorFile1() {
  using namespace std;
  char *cFileString = "TestFile1.xml";

  //Open file to write to
  fstream oOut;
  oOut.open(cFileString, ios::out | ios::trunc);

  oOut << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>"
       << "<paramFile fileCode=\"06010101\">"
       << "<plot>"
       << "<timesteps>2</timesteps>"
       << "<yearsPerTimestep>1</yearsPerTimestep>"
       << "<randomSeed>1</randomSeed>"
       << "<plot_lenX>200.0</plot_lenX>"
       << "<plot_lenY>200.0</plot_lenY>"
       << "<plot_latitude>55.37</plot_latitude>"
       << "<plot_precip_mm_yr>1150.645781</plot_precip_mm_yr>"
       << "<plot_temp_C>12.88171785</plot_temp_C>"
       << "</plot>"
       << "<trees>"
       << "<tr_speciesList>"
       << "<tr_species speciesName=\"Species_1\" />"
       << "<tr_species speciesName=\"Species_2\" />"
       << "</tr_speciesList>"
       << "<tr_seedDiam10Cm>0.1</tr_seedDiam10Cm>"
       << "<tr_minAdultDBH>"
       << "<tr_madVal species=\"Species_1\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_2\">4.0</tr_madVal>"
       << "</tr_minAdultDBH>"
       << "<tr_maxSeedlingHeight>"
       << "<tr_mshVal species=\"Species_1\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_2\">1.35</tr_mshVal>"
       << "</tr_maxSeedlingHeight>"
       << "</trees>"
       << "<allometry>"
       << "<tr_canopyHeight>"
       << "<tr_chVal species=\"Species_1\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_2\">39.48</tr_chVal>"
       << "</tr_canopyHeight>"
       << "<tr_stdAsympCrownRad>"
       << "<tr_sacrVal species=\"Species_1\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_2\">0.0549</tr_sacrVal>"
       << "</tr_stdAsympCrownRad>"
       << "<tr_stdCrownRadExp>"
       << "<tr_screVal species=\"Species_1\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_2\">1.0</tr_screVal>"
       << "</tr_stdCrownRadExp>"
       << "<tr_conversionDiam10ToDBH>"
       << "<tr_cdtdVal species=\"Species_1\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_2\">0.8008</tr_cdtdVal>"
       << "</tr_conversionDiam10ToDBH>"
       << "<tr_interceptDiam10ToDBH>"
       << "<tr_idtdVal species=\"Species_1\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_2\">0</tr_idtdVal>"
       << "</tr_interceptDiam10ToDBH>"
       << "<tr_stdAsympCrownHt>"
       << "<tr_sachVal species=\"Species_1\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_2\">0.389</tr_sachVal>"
       << "</tr_stdAsympCrownHt>"
       << "<tr_stdCrownHtExp>"
       << "<tr_scheVal species=\"Species_1\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_2\">1.0</tr_scheVal>"
       << "</tr_stdCrownHtExp>"
       << "<tr_slopeOfHeight-Diam10>"
       << "<tr_sohdVal species=\"Species_1\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_2\">0.03418</tr_sohdVal>"
       << "</tr_slopeOfHeight-Diam10>"
       << "<tr_slopeOfAsymHeight>"
       << "<tr_soahVal species=\"Species_1\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_2\">0.0299</tr_soahVal>"
       << "</tr_slopeOfAsymHeight>"
       << "<tr_whatSeedlingHeightDiam>"
       << "<tr_wsehdVal species=\"Species_1\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_2\">0</tr_wsehdVal>"
       << "</tr_whatSeedlingHeightDiam>"
       << "<tr_whatSaplingHeightDiam>"
       << "<tr_wsahdVal species=\"Species_1\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_2\">0</tr_wsahdVal>"
       << "</tr_whatSaplingHeightDiam>"
       << "<tr_whatAdultHeightDiam>"
       << "<tr_wahdVal species=\"Species_1\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_2\">0</tr_wahdVal>"
       << "</tr_whatAdultHeightDiam>"
       << "<tr_whatAdultCrownRadDiam>"
       << "<tr_wacrdVal species=\"Species_1\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_2\">0</tr_wacrdVal>"
       << "</tr_whatAdultCrownRadDiam>"
       << "<tr_whatAdultCrownHeightHeight>"
       << "<tr_wachhVal species=\"Species_1\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_2\">0</tr_wachhVal>"
       << "</tr_whatAdultCrownHeightHeight>"
       << "<tr_whatSaplingCrownRadDiam>"
       << "<tr_wscrdVal species=\"Species_1\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_2\">0</tr_wscrdVal>"
       << "</tr_whatSaplingCrownRadDiam>"
       << "<tr_whatSaplingCrownHeightHeight>"
       << "<tr_wschhVal species=\"Species_1\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_2\">0</tr_wschhVal>"
       << "</tr_whatSaplingCrownHeightHeight>"
       << "</allometry>"
       << "<behaviorList>"
       << "<behavior>"
       << "<behaviorName>tree biomass calculator</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "</behavior>"
       << "<behavior>"
       << "<behaviorName>FIA Merchantable Stem Wood Volume</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_1\" type=\"Adult\"/>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "</behavior>"
       << "</behaviorList>";

  oOut << "<analysis>"
       << "<bi_a>"
       << "<bi_aVal species=\"Species_1\">-0.99</bi_aVal>"
       << "<bi_aVal species=\"Species_2\">-1.01</bi_aVal>"
       << "</bi_a>"
       << "<bi_b>"
       << "<bi_bVal species=\"Species_1\">2.2</bi_bVal>"
       << "<bi_bVal species=\"Species_2\">2.41</bi_bVal>"
       << "</bi_b>"
       << "<bi_c>"
       << "<bi_cVal species=\"Species_1\">0.9</bi_cVal>"
       << "<bi_cVal species=\"Species_2\">1</bi_cVal>"
       << "</bi_c>"
       << "<bi_d>"
       << "<bi_dVal species=\"Species_1\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_2\">1</bi_dVal>"
       << "</bi_d>"
       << "<bi_e>"
       << "<bi_eVal species=\"Species_1\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_2\">0</bi_eVal>"
       << "</bi_e>"
       << "<bi_eqID>"
       << "<bi_eiVal species=\"Species_1\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_2\">1</bi_eiVal>"
       << "</bi_eqID>"
       << "<bi_dbhUnits>"
       << "<bi_duVal species=\"Species_1\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_2\">1</bi_duVal>"
       << "</bi_dbhUnits>"
       << "<bi_biomassUnits>"
       << "<bi_buVal species=\"Species_1\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_2\">1</bi_buVal>"
       << "</bi_biomassUnits>"
       << "<bi_useCorrectionFactor>"
       << "<bi_ucfVal species=\"Species_1\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_2\">1</bi_ucfVal>"
       << "</bi_useCorrectionFactor>"
       << "<bi_correctionFactorValue>"
       << "<bi_cfvVal species=\"Species_1\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_2\">1</bi_cfvVal>"
       << "</bi_correctionFactorValue>"
       << "<bi_whatDia>"
       << "<bi_wdVal species=\"Species_1\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_2\">0</bi_wdVal>"
       << "</bi_whatDia>"

       << "<an_fiaVolB1>"
       << "<an_fvb1Val species=\"Species_1\">-0.3065</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_2\">-0.3737</an_fvb1Val>"
       << "</an_fiaVolB1>"
       << "<an_fiaVolB2>"
       << "<an_fvb2Val species=\"Species_1\">-5.424</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_2\">-1.8055</an_fvb2Val>"
       << "</an_fiaVolB2>"
       << "<an_fiaVolSpgr>"
       << "<an_fvsVal species=\"Species_1\">0.51</an_fvsVal>"
       << "<an_fvsVal species=\"Species_2\">0.52</an_fvsVal>"
       << "</an_fiaVolSpgr>"
       << "</analysis>"
       << "</paramFile>";

  return cFileString;
}

////////////////////////////////////////////////////////////////////////////
//  WriteXMLErrorFile2()
////////////////////////////////////////////////////////////////////////////
char* clTestMerchantableStemWoodVolume::WriteXMLErrorFile2() {
  using namespace std;
  char *cFileString = "TestFile1.xml";

  //Open file to write to
  fstream oOut;
  oOut.open(cFileString, ios::out | ios::trunc);

  oOut << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>"
       << "<paramFile fileCode=\"06010101\">"
       << "<plot>"
       << "<timesteps>2</timesteps>"
       << "<yearsPerTimestep>1</yearsPerTimestep>"
       << "<randomSeed>1</randomSeed>"
       << "<plot_lenX>200.0</plot_lenX>"
       << "<plot_lenY>200.0</plot_lenY>"
       << "<plot_latitude>55.37</plot_latitude>"
       << "<plot_precip_mm_yr>1150.645781</plot_precip_mm_yr>"
       << "<plot_temp_C>12.88171785</plot_temp_C>"
       << "</plot>"
       << "<trees>"
       << "<tr_speciesList>"
       << "<tr_species speciesName=\"Species_1\" />"
       << "<tr_species speciesName=\"Species_2\" />"
       << "</tr_speciesList>"
       << "<tr_seedDiam10Cm>0.1</tr_seedDiam10Cm>"
       << "<tr_minAdultDBH>"
       << "<tr_madVal species=\"Species_1\">4.0</tr_madVal>"
       << "<tr_madVal species=\"Species_2\">4.0</tr_madVal>"
       << "</tr_minAdultDBH>"
       << "<tr_maxSeedlingHeight>"
       << "<tr_mshVal species=\"Species_1\">1.35</tr_mshVal>"
       << "<tr_mshVal species=\"Species_2\">1.35</tr_mshVal>"
       << "</tr_maxSeedlingHeight>"
       << "</trees>"
       << "<allometry>"
       << "<tr_canopyHeight>"
       << "<tr_chVal species=\"Species_1\">39.48</tr_chVal>"
       << "<tr_chVal species=\"Species_2\">39.48</tr_chVal>"
       << "</tr_canopyHeight>"
       << "<tr_stdAsympCrownRad>"
       << "<tr_sacrVal species=\"Species_1\">0.0549</tr_sacrVal>"
       << "<tr_sacrVal species=\"Species_2\">0.0549</tr_sacrVal>"
       << "</tr_stdAsympCrownRad>"
       << "<tr_stdCrownRadExp>"
       << "<tr_screVal species=\"Species_1\">1.0</tr_screVal>"
       << "<tr_screVal species=\"Species_2\">1.0</tr_screVal>"
       << "</tr_stdCrownRadExp>"
       << "<tr_conversionDiam10ToDBH>"
       << "<tr_cdtdVal species=\"Species_1\">0.8008</tr_cdtdVal>"
       << "<tr_cdtdVal species=\"Species_2\">0.8008</tr_cdtdVal>"
       << "</tr_conversionDiam10ToDBH>"
       << "<tr_interceptDiam10ToDBH>"
       << "<tr_idtdVal species=\"Species_1\">0</tr_idtdVal>"
       << "<tr_idtdVal species=\"Species_2\">0</tr_idtdVal>"
       << "</tr_interceptDiam10ToDBH>"
       << "<tr_stdAsympCrownHt>"
       << "<tr_sachVal species=\"Species_1\">0.389</tr_sachVal>"
       << "<tr_sachVal species=\"Species_2\">0.389</tr_sachVal>"
       << "</tr_stdAsympCrownHt>"
       << "<tr_stdCrownHtExp>"
       << "<tr_scheVal species=\"Species_1\">1.0</tr_scheVal>"
       << "<tr_scheVal species=\"Species_2\">1.0</tr_scheVal>"
       << "</tr_stdCrownHtExp>"
       << "<tr_slopeOfHeight-Diam10>"
       << "<tr_sohdVal species=\"Species_1\">0.03418</tr_sohdVal>"
       << "<tr_sohdVal species=\"Species_2\">0.03418</tr_sohdVal>"
       << "</tr_slopeOfHeight-Diam10>"
       << "<tr_slopeOfAsymHeight>"
       << "<tr_soahVal species=\"Species_1\">0.0299</tr_soahVal>"
       << "<tr_soahVal species=\"Species_2\">0.0299</tr_soahVal>"
       << "</tr_slopeOfAsymHeight>"
       << "<tr_whatSeedlingHeightDiam>"
       << "<tr_wsehdVal species=\"Species_1\">0</tr_wsehdVal>"
       << "<tr_wsehdVal species=\"Species_2\">0</tr_wsehdVal>"
       << "</tr_whatSeedlingHeightDiam>"
       << "<tr_whatSaplingHeightDiam>"
       << "<tr_wsahdVal species=\"Species_1\">0</tr_wsahdVal>"
       << "<tr_wsahdVal species=\"Species_2\">0</tr_wsahdVal>"
       << "</tr_whatSaplingHeightDiam>"
       << "<tr_whatAdultHeightDiam>"
       << "<tr_wahdVal species=\"Species_1\">0</tr_wahdVal>"
       << "<tr_wahdVal species=\"Species_2\">0</tr_wahdVal>"
       << "</tr_whatAdultHeightDiam>"
       << "<tr_whatAdultCrownRadDiam>"
       << "<tr_wacrdVal species=\"Species_1\">0</tr_wacrdVal>"
       << "<tr_wacrdVal species=\"Species_2\">0</tr_wacrdVal>"
       << "</tr_whatAdultCrownRadDiam>"
       << "<tr_whatAdultCrownHeightHeight>"
       << "<tr_wachhVal species=\"Species_1\">0</tr_wachhVal>"
       << "<tr_wachhVal species=\"Species_2\">0</tr_wachhVal>"
       << "</tr_whatAdultCrownHeightHeight>"
       << "<tr_whatSaplingCrownRadDiam>"
       << "<tr_wscrdVal species=\"Species_1\">0</tr_wscrdVal>"
       << "<tr_wscrdVal species=\"Species_2\">0</tr_wscrdVal>"
       << "</tr_whatSaplingCrownRadDiam>"
       << "<tr_whatSaplingCrownHeightHeight>"
       << "<tr_wschhVal species=\"Species_1\">0</tr_wschhVal>"
       << "<tr_wschhVal species=\"Species_2\">0</tr_wschhVal>"
       << "</tr_whatSaplingCrownHeightHeight>"
       << "</allometry>"
       << "<behaviorList>"
       << "<behavior>"
       << "<behaviorName>tree biomass calculator</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_1\" type=\"Sapling\"/>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "</behavior>"
       << "<behavior>"
       << "<behaviorName>FIA Merchantable Stem Wood Volume</behaviorName>"
       << "<version>1</version>"
       << "<applyTo species=\"Species_1\" type=\"Sapling\"/>"
       << "<applyTo species=\"Species_2\" type=\"Adult\"/>"
       << "</behavior>"
       << "</behaviorList>";

  oOut << "<analysis>"
       << "<bi_a>"
       << "<bi_aVal species=\"Species_1\">-0.99</bi_aVal>"
       << "<bi_aVal species=\"Species_2\">-1.01</bi_aVal>"
       << "</bi_a>"
       << "<bi_b>"
       << "<bi_bVal species=\"Species_1\">2.2</bi_bVal>"
       << "<bi_bVal species=\"Species_2\">2.41</bi_bVal>"
       << "</bi_b>"
       << "<bi_c>"
       << "<bi_cVal species=\"Species_1\">0.9</bi_cVal>"
       << "<bi_cVal species=\"Species_2\">1</bi_cVal>"
       << "</bi_c>"
       << "<bi_d>"
       << "<bi_dVal species=\"Species_1\">1</bi_dVal>"
       << "<bi_dVal species=\"Species_2\">1</bi_dVal>"
       << "</bi_d>"
       << "<bi_e>"
       << "<bi_eVal species=\"Species_1\">0</bi_eVal>"
       << "<bi_eVal species=\"Species_2\">0</bi_eVal>"
       << "</bi_e>"
       << "<bi_eqID>"
       << "<bi_eiVal species=\"Species_1\">1</bi_eiVal>"
       << "<bi_eiVal species=\"Species_2\">1</bi_eiVal>"
       << "</bi_eqID>"
       << "<bi_dbhUnits>"
       << "<bi_duVal species=\"Species_1\">0</bi_duVal>"
       << "<bi_duVal species=\"Species_2\">1</bi_duVal>"
       << "</bi_dbhUnits>"
       << "<bi_biomassUnits>"
       << "<bi_buVal species=\"Species_1\">1</bi_buVal>"
       << "<bi_buVal species=\"Species_2\">1</bi_buVal>"
       << "</bi_biomassUnits>"
       << "<bi_useCorrectionFactor>"
       << "<bi_ucfVal species=\"Species_1\">1</bi_ucfVal>"
       << "<bi_ucfVal species=\"Species_2\">1</bi_ucfVal>"
       << "</bi_useCorrectionFactor>"
       << "<bi_correctionFactorValue>"
       << "<bi_cfvVal species=\"Species_1\">1</bi_cfvVal>"
       << "<bi_cfvVal species=\"Species_2\">1</bi_cfvVal>"
       << "</bi_correctionFactorValue>"
       << "<bi_whatDia>"
       << "<bi_wdVal species=\"Species_1\">0</bi_wdVal>"
       << "<bi_wdVal species=\"Species_2\">0</bi_wdVal>"
       << "</bi_whatDia>"

       << "<an_fiaVolB1>"
       << "<an_fvb1Val species=\"Species_1\">-0.3065</an_fvb1Val>"
       << "<an_fvb1Val species=\"Species_2\">-0.3737</an_fvb1Val>"
       << "</an_fiaVolB1>"
       << "<an_fiaVolB2>"
       << "<an_fvb2Val species=\"Species_1\">-5.424</an_fvb2Val>"
       << "<an_fvb2Val species=\"Species_2\">-1.8055</an_fvb2Val>"
       << "</an_fiaVolB2>"
       << "<an_fiaVolSpgr>"
       << "<an_fvsVal species=\"Species_1\">0.51</an_fvsVal>"
       << "<an_fvsVal species=\"Species_2\">0.52</an_fvsVal>"
       << "</an_fiaVolSpgr>"
       << "</analysis>"
       << "</paramFile>";

  return cFileString;
}
