//---------------------------------------------------------------------------
// TestOutputShort
//---------------------------------------------------------------------------
#if !defined(TestOutputShort_H)
  #define TestOutputShort_H

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>

class clSimManager;

/**
 * This class tests the short output behavior (clOutputShort).
*/
class clTestOutputShort : public CppUnit::TestFixture {

public:

  /**
  * Groups all tests into one.
  */
  void TestOutputShort();

private:

  /**
   * Tests file creation and saving. WriteXMLFile1() does setup. The filename
   * already has the extension on it.
   * @param p_oSimManager Sim manager object.
   */
  void NormalProcessingRun1(clSimManager *p_oSimManager);

  /**
   * Tests file creation and saving. WriteXMLFile2() does setup. The filename
   * already has the extension on it.
   * @param p_oSimManager Sim manager object.
   */
  void NormalProcessingRun2(clSimManager *p_oSimManager);

  /**
   * Writes a parameter file for normal processing run 1.
   * @return Filename written.
   */
  char* WriteXMLFile1();

  /**
   * Writes a parameter file for normal processing run 1.
   * @return Filename written.
   */
  char* WriteXMLFile2();


};
//---------------------------------------------------------------------------

#endif // TestMastingSpatialDisperse_H
