//---------------------------------------------------------------------------
// TestTempDependentNeighborhoodDisperse
//---------------------------------------------------------------------------
#if !defined(TestTempDependentNeighborhoodDisperse_H)
  #define TestTempDependentNeighborhoodDisperse_H

  #include <cppunit/TestFixture.h>
  #include <cppunit/TestCaller.h>

  class clSimManager;

  /**
   * This class tests the clTempDependentNeighborhoodDisperse class.
   */
  class clTestTempDependentNeighborhoodDisperse : public CppUnit::TestFixture
  {

  public:

  /**
  * Rolls together all the tests.
  */
  void TestTempDependentNeighborhoodDisperse();

  private:

  /**
   * Tests dispersal, run 1.  It will cause a parameter file to be
   * written and then passed to a clSimManager object.  That object will read
   * it. Then the dispersal behavior is run. The number of
   * seedlings per grid cell is compared with expected values.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodDisperse1(clSimManager *p_oSimManager);

  /**
   * Tests dispersal, run 2.  It will cause a parameter file to be
   * written and then passed to a clSimManager object.  That object will read
   * it. Then the dispersal behavior is run. The number of seeds
   * per grid cell is compared with expected values.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodDisperse2(clSimManager *p_oSimManager);

  /**
   * Tests dispersal, run 3. It will cause a parameter file to be
   * written and then passed to a clSimManager object.  That object will read
   * it. Then the dispersal behavior is run. The number of seeds
   * per grid cell is compared with expected values.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodDisperse3(clSimManager *p_oSimManager);

  /**
   * Tests dispersal, run 4. It will cause a parameter file to be
   * written and then passed to a clSimManager object.  That object will read
   * it. Then the dispersal behavior is run. The number of seeds
   * per grid cell is compared with expected values.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodDisperse4(clSimManager *p_oSimManager);

  /**
   * Writes a parameter file to direct testing.
   * @param iYearsPerTimestep The desired number of years per time step.
   * @return Filename written.
   */
  char * WriteXMLFile(int iYearsPerTimestep );

  /**
   * Writes a parameter file to direct testing.
   * @return Filename written.
   */
  char * WriteXMLFile3();

  /**
   * Writes a parameter file to direct testing.
   * @return Filename written.
   */
  char * WriteXMLFile4();
};
//---------------------------------------------------------------------------
#endif // TestTempDependentNeighborhoodDisperse_H
