//---------------------------------------------------------------------------
// TestTempDependentNeighborhoodSurvival
//---------------------------------------------------------------------------
#if !defined(TestTempDependentNeighborhoodSurvival_H)
  #define TestTempDependentNeighborhoodSurvival_H

  #include <cppunit/TestFixture.h>
  #include <cppunit/TestCaller.h>

  class clSimManager;

  /**
   * This class tests the clTempDependentNeighborhoodSurvival class.
   */
  class clTestTempDependentNeighborhoodSurvival : public CppUnit::TestFixture
  {

  public:

  /**
  * Rolls together all the tests.
  */
  void TestTempDependentNeighborhoodSurvival();

  private:

  /**
   * Tests run 1.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodSurvival1(clSimManager *p_oSimManager);

  /**
   * Tests run 2.
   * @param p_oSimManager Sim manager to direct testing.
   */
  void TestTempDependentNeighborhoodSurvival2(clSimManager *p_oSimManager);

  /**
  * Tests error processing for input files.
  * @param p_oSimManager Sim manager to direct testing.
  */
  void TestErrorProcessing(clSimManager *p_oSimManager);

  /**
   * Writes a parameter file to direct testing.
   * @param iYearsPerTimestep The desired number of years per time step.
   * @return Filename written.
   */
  char * WriteXMLFile(int iYearsPerTimestep );

  /**
   * Writes a parameter file to direct testing. One of the values for N
   * equals zero.
   * @return Filename written.
   */
  char * WriteXMLErrorFile1();

  /**
   * Writes a parameter file to direct testing. The value for search radius
   * is less than zero.
   * @return Filename written.
   */
  char * WriteXMLErrorFile2();
};
//---------------------------------------------------------------------------
#endif // TestTempDependentNeighborhoodSurvival_H
